#!/usr/bin/env python
# -*- coding: UTF-8 -*-

"""
Пример 1 к статье "Построение графиков с помощью matplotlib и pyGTK."
Автор: Попов О.Б,
2007 г.
"""

import pygtk
pygtk.require('2.0')
import gtk

from matplotlib.axes import Subplot
from matplotlib.figure import Figure,SubplotParams
from matplotlib.numerix import arange, sin, pi,cos,exp,multiply
from matplotlib.backends.backend_gtkagg import FigureCanvasGTKAgg as FigureCanvas

from matplotlib.backends.backend_gtk import NavigationToolbar2GTK as NavigationToolbar


class SimplePlotDemo:
    def __init__(self):
         # Создаём новое окно
        self.window = gtk.Window(gtk.WINDOW_TOPLEVEL)
        # Заголовок окна
        self.window.set_title("Пример встраивания графика в окно GTK") 
        self.window.set_border_width(8)#  размер рамки
        self.window.set_default_size(800,600)# размер окна
        # callback для события delete
        self.window.connect("delete_event", self.delete_event)
        self.window.connect("destroy", self.destroy) # callback
        self.vbox1 = gtk.VBox(False, 0)
        self.window.add (self.vbox1)
        #создать диаграмму
        self.draw_plot()
        #scrolled window 
        self.scrolledwindow1 = gtk.ScrolledWindow()
        self.scrolledwindow1.show ()
        self.vbox1.pack_start (self.scrolledwindow1, True,True, 0)
        self.scrolledwindow1.set_border_width ( 8)
        # "запаковать" диграмму внутрь gtk.DrawingArea
        self.canvas = FigureCanvas(self.figure1)  
        # минимальнй размер области рисования
        self.canvas.set_size_request(700,500) 
        self.scrolledwindow1.add_with_viewport(self.canvas)
        #добавляем  toolbar
        self.toolbar = NavigationToolbar(self.canvas, self.window)
        self.vbox1.pack_start(	self.toolbar, False, False)
        self.window.show_all()
        
    def draw_plot(self):
        #рисуем график функции
        self.figure1 = Figure(figsize=(4,4), dpi=85,facecolor='lavender',
        edgecolor='lavenderblush',linewidth = 12.0, 
        frameon = True,subplotpars=SubplotParams(left=0.1, bottom=0.1, 
        right=0.9, top=0.9,wspace=0.1,hspace=0.1))
        self.subplot1=self.figure1.add_subplot(1,1,1)#
        self.subplot1.set_title(u' График функции y=sin(2*pi*x)*exp(-x)',fontsize=18)
        #массивы значений для оси X
        X1=arange(0.0,5.0,0.1)
        X2=arange(0.0,5.0,0.02)
        #определим функцию для графика
        def f(t):
            s1 = sin(2*pi*t)
            e1 = exp(-t)
            return multiply(s1,e1)
        #рисуем график функции  сплошной синей линией
        line2=self.subplot1.plot(X2,f(X2),color='blue')
        #рисуем график функции для точек X1 маркерами
        #( красными окружностями)
        line1=self.subplot1.plot(X1,f(X1),'ro')
        line2[0].set_linewidth(3.2) #толщина линий
        line1[0].set_markersize(8) #размер маркера
        #координатную сетку на задний план
        self.subplot1.set_axisbelow(True)
        #координатную сетку рисовать		
        self.subplot1.grid(True)
        
    #Callbacks:
    def destroy(self, widget,data=None):
        gtk.main_quit()
    def delete_event(self, widget, event, data=None):
        return False	      

SimplePlotDemApp=SimplePlotDemo()
gtk.main()
